WizBot CLI Guide (via Bash Installer)¶
Supported Operating Systems¶
- Ubuntu: 20.04, 22.04, 24.04
- Mint: 19, 20, 21
- Debian: 10, 11, 12
- RockyLinux: 8, 9
- AlmaLinux: 8, 9
- openSUSE Leap: 15.5, 15.6
- openSUSE Tumbleweed
- Fedora: 38, 39, 40, 41, 42
- Arch & Artix
- macOS 13 (Ventura) or later
Prerequisites¶
macOS:
Linux:
24/7 Up-time via VPS (Digital Ocean Guide)
Setting up WizBot on a Linux VPS (Digital Ocean Droplet)¶
If you want WizBot to play music for you 24/7 without having to hosting it on your PC and want to keep it cheap, reliable and convenient as possible, you can try WizBot on Linux Digital Ocean Droplet using the link DigitalOcean (by using this link, you will get $10 credit and also support WizBot)
To set up the VPS, please select the options below
These are the min requirements you must follow:
OS: Any between Ubuntu, Fedora, and Debian
Droplet Type: SHARED CPU | Basic
CPU options: Regular | Disk type: SSD
6$/mo
1 GB / 1 CPU
25 GB SSD Disk
1000 GB transfer
Note: You can select the cheapest option with 512 MB / 1 CPU but this has been a hit or miss.
Datacenter region: Choose one depending on where you are located.
Authentication: Password or SSH
(Select SSH if you know what you are doing, otherwise choose password)
Click create droplet
IP address and root password (in your e-mail)
to login, it's time to get started.
This section is only relevant to those who want to host WizBot on DigitalOcean. Go through this whole section before setting the bot up.
Prerequisites¶
- Download PuTTY
- Download WinSCP (optional)
- Create and invite the bot.
Starting up¶
- Open PuTTY and paste or enter your
IP address
and then click Open. If you entered your Droplets IP address correctly, it should show login as: in a newly opened window. - Now for login as:, type
root
and press enter. - It should then ask for a password. Type the
root password
you have received in your e-mail address, then press Enter.
If you are running your droplet for the first time, it will most likely ask you to change your root password. To do that, copy the password you've received by e-mail and paste it on PuTTY.
- To paste, just right-click the window (it won't show any changes on the screen), then press Enter.
- Type a new password somewhere, copy and paste it on PuTTY. Press Enter then paste it again.
Save the new password somewhere safe.
After that, your droplet should be ready for use.
Creating a Discord Bot & Getting Credentials
Creating your own Discord bot¶
This guide will show you how to create your own discord bot, invite it to your server, and obtain the credentials needed to run it.
- Go to the Discord developer application page.
- Log in with your Discord account.
- Click New Application.
- Fill out the
Name
field however you like, accept the terms, and confirm. - Go to the Bot tab on the left sidebar.
- Click on the
Add a Bot
button and confirm that you do want to add a bot to this app. - Optional: Add bot's avatar and description.
- Copy your Token to
creds.yml
as shown above. - Scroll down to the
Privileged Gateway Intents
section- You MUST enable the following:
- PRESENCE INTENT
- SERVER MEMBERS INTENT
- MESSAGE CONTENT INTENT
- You MUST enable the following:
Inviting your bot to your server¶
- On the General Information tab, copy your
Application ID
from your applications page. - Replace the
YOUR_CLIENT_ID_HERE
in this link:https://discordapp.com/oauth2/authorize?client_id=YOUR_CLIENT_ID_HERE&scope=bot&permissions=66186303
with yourClient ID
- The link should now look something like this:
https://discordapp.com/oauth2/authorize?client_id=123123123123&scope=bot&permissions=66186303
- Access that newly created link, pick your Discord server, click
Authorize
and confirm with the captcha at the end - The bot should now be in your server
Installation Instructions¶
Open Terminal (if you're on an installation with a window manager) and navigate to the location where you want to install the bot (for example cd ~
)
-
First make sure that curl is installed
sudo apt install curl
sudo dnf install curl
sudo zypper install curl
sudo pacman -S curl
brew install curl
-
Download and run the new installer script
cd ~ curl -L -o w-install.sh https://raw.githubusercontent.com/Wizkiller96/bash-installer/refs/heads/v6/w-install.sh bash w-install.sh
- Install the bot (type
1
and press enter) - Edit creds (type
3
and press enter)- ALTERNATIVELY, you can exit the installer (option
6
) and editwizbot/creds.yml
file yourself
- ALTERNATIVELY, you can exit the installer (option
- Follow the instruction below to create your own Discord bot and obtain the credentials needed to run it.
- After you're done, you can close nano (and save the file) by inputting, in order:
CTRL
+X
Y
Enter
- After you're done, you can close nano (and save the file) by inputting, in order:
- Run the installer script again
bash w-install.sh
- Run the bot (type
3
and press enter) - Done!
Update Instructions¶
- ⚠ Stop the bot ⚠
- Navigate to your bot's folder, we'll use home directory as an example
cd ~
- Simply re-install the bot with a newer version by running the installer script
curl -L -o w-install.sh https://raw.githubusercontent.com/Wizkiller96/bash-installer/refs/heads/v6/w-install.sh && bash w-install.sh
- Select option 1, and select a NEWER version
Running WizBot¶
There are two main methods to run WizBot: using tmux
(macOS and Linux) or using systemd
with a script (Linux only).
Using tmux
is the simplest method, and is therefore recommended for most users.
Warning
Before proceeding, make sure your bot is not currently running by either running .die
in your Discord server or exiting the process with Ctrl+C
.
- Access the directory where
w-install.sh
andwizbot
is located. - Create a new tmux session:
tmux new -s wizbot
- The above command will create a new session named wizbot. You may replace wizbot with any name you prefer.
- Run the installer:
bash w-install.sh
- Start the bot by typing
3
and pressingEnter
. - Detach from the tmux session, allowing the bot to run in the background:
- Press
Ctrl
+B
- Then press
D
- Press
Now check your Discord server, the bot should be online. WizBot should now be running in the background of your system.
To re-open the tmux session to either update, restart, or whatever, execute tmux a -t wizbot
. (Make sure to replace "wizbot" with your session name. If you didn't change it, leave it as it is.)
Note
Systemd is only available on Linux. macOS utilizes Launchd, which is not covered in this guide. If you're on macOS, please use the tmux
method, or use WizBot Updater to run WizBot.
This method is a bit more complex and involved, but comes with the added benefit of better error logging and control over what happens before and after the startup of WizBot.
- Access the directory where
w-install.sh
andwizbot
is located. - Use the following command to create a service that will be used to execute
WizBotRun.bash
:echo "[Unit] Description=WizBot service After=network.target StartLimitIntervalSec=60 StartLimitBurst=2 [Service] Type=simple User=$USER WorkingDirectory=$PWD ExecStart=/bin/bash WizBotRun.bash #ExecStart=./wizbot/WizBot Restart=on-failure RestartSec=5 StandardOutput=journal StandardError=journal SyslogIdentifier=WizBot [Install] WantedBy=multi-user.target" | sudo tee /etc/systemd/system/wizbot.service
- Make the new service available:
sudo systemctl daemon-reload
- Use the following command to create a script that will be used to start WizBot:
cat <<EOF > WizBotRun.bash #!/bin/bash export PATH="$HOME/.local/bin:$PATH" is_python3_installed=\$(command -v python3 &>/dev/null && echo true || echo false) is_yt_dlp_installed=\$(command -v yt-dlp &>/dev/null && echo true || echo false) [[ \$is_python3_installed == true ]] \\ && echo "[INFO] python3 path: \$(which python3)" \\ && echo "[INFO] python3 version: \$(python3 --version)" [[ \$is_yt_dlp_installed == true ]] \\ && echo "[INFO] yt-dlp path: \$(which yt-dlp)" echo "[INFO] Running WizBot in the background with auto restart" if [[ \$is_yt_dlp_installed == true ]]; then yt-dlp -U || echo "[ERROR] Failed to update 'yt-dlp'" >&2 fi echo "[INFO] Starting WizBot..." while true; do if [[ -d $PWD/wizbot ]]; then cd "$PWD/wizbot" || { echo "[ERROR] Failed to change working directory to '$PWD/wizbot'" >&2 echo "[INFO] Exiting..." exit 1 } else echo "[WARN] '$PWD/wizbot' doesn't exist" >&2 echo "[INFO] Exiting..." exit 1 fi ./WizBot || { echo "[ERROR] An error occurred when trying to start WizBot" >&2 echo "[INFO] Exiting..." exit 1 } echo "[INFO] Waiting 5 seconds..." sleep 5 if [[ \$is_yt_dlp_installed == true ]]; then yt-dlp -U || echo "[ERROR] Failed to update 'yt-dlp'" >&2 fi echo "[INFO] Restarting WizBot..." done echo "[INFO] Stopping WizBot..." EOF
With everything set up, you can run WizBot in one of three modes:
- Auto-Restart Mode: WizBot will restart automatically if you restart it via the
.die
command.- To enable this mode, start the service:
sudo systemctl start wizbot
- To enable this mode, start the service:
- Auto-Restart on Reboot Mode: In addition to auto-restarting after
.die
, WizBot will also start automatically on system reboot.- To enable this mode, run:
sudo systemctl enable wizbot sudo systemctl start wizbot
- To enable this mode, run:
- Standard Mode: WizBot will stop completely when you use
.die
, without restarting automatically.- To switch to this mode:
- Stop the service:
sudo systemctl stop wizbot
- Edit the service file:
sudo <editor> /etc/systemd/system/wizbot.service
- Modify the
ExecStart
line:- Comment out:
ExecStart=/bin/bash WizBotRun.bash
- Uncomment:
#ExecStart=./wizbot/WizBot
- Comment out:
- Save and exit the editor.
- Reload systemd:
sudo systemctl daemon-reload
- Disable automatic startup:
sudo systemctl disable wizbot
- Start WizBot manually:
sudo systemctl start wizbot
- Stop the service:
- To switch to this mode: